;NASM Win32 coding tutorial pt. 4k  -  von T$ (ts@deinmeister.de)
;
;compile with:
;NASMW.EXE -fobj win005_n.asm
;link with:
;ALINK.EXE -c -oPE  -subsys console win005_n


	  %include "win32n.inc"       

	 EXTERN ExitProcess
	 IMPORT ExitProcess kernel32.dll

	 EXTERN GetStdHandle
	 IMPORT GetStdHandle kernel32.dll
	 EXTERN WriteFile
	 IMPORT WriteFile kernel32.dll
	 EXTERN CloseHandle
	 IMPORT CloseHandle kernel32.dll


	 segment .data USE32         

	textdata db 13,10,13,10
		 db "-----------------------------------------------------------------------------",13,10
		 db " * Text output using standard handles to the console.",13,10," *",13,10
		 db " * It is possible to redirect it to somewhere else",13,10
		 db " * Use the following command lines for redirection:",13,10
		 db " *",13,10
		 db " * win005.exe > lpt1      (outputs the text to the printer at printer port 1)",13,10
		 db " * win005.exe > com1      (outputs the text to the serial port 1)",13,10
		 db " * win005.exe > con       (outputs the text to the console (default setting))",13,10
		 db " * win005.exe > info.txt  (outputs the text to the file info.txt on the disk)",13,10
		 db " *",13,10
		 db "-----------------------------------------------------------------------------",13,10

	textende:

	filehandle dd 0

	 segment .code USE32 
                
	  ..start                     

	push dword STD_OUTPUT_HANDLE
	call [GetStdHandle]

	mov [filehandle],eax

	mov eax,esp
	sub esp,4			;allocate 1 dword from the stack for temporary storage
					;address of dword is stored in eax

	push dword 0
	push eax
	push dword textende-textdata	;text data size
	push dword textdata		;text data address
	push dword [filehandle]
	call [WriteFile]

	add esp,4			;deallocate dword taken from stack, although it is not absolutely needed here

	push dword [filehandle]
	call [CloseHandle]

	push dword 0
	call [ExitProcess]





